import sys
import os

from PyQt5 import QtCore, QtGui, QtWidgets, uic
from PyQt5.QtWidgets import QLabel

def getScriptPath():
    return os.path.dirname(os.path.realpath(sys.argv[0]))

class Config(QtGui.QWidget):

    def __init__(self, parent=None):
        super(Config, self).__init__(parent)

        self.ui = uic.loadUi(getScriptPath() + "/config.ui", self)

        # CONNECT SIGNALS
        self.ui.text_th_h_0.editingFinished.connect(self.update_th_h_0)
        self.ui.text_th_h_1.editingFinished.connect(self.update_th_h_1)
        self.ui.text_th_h_2.editingFinished.connect(self.update_th_h_2)
        self.ui.text_th_h_3.editingFinished.connect(self.update_th_h_3)
        self.ui.text_th_h_4.editingFinished.connect(self.update_th_h_4)
        self.ui.text_th_h_5.editingFinished.connect(self.update_th_h_5)
        self.ui.text_th_h_6.editingFinished.connect(self.update_th_h_6)
        self.ui.text_th_h_7.editingFinished.connect(self.update_th_h_7)
        self.ui.text_nsamp_h.editingFinished.connect(self.update_nsamp_h)

        self.ui.text_th_m_0.editingFinished.connect(self.update_th_m_0)
        self.ui.text_th_m_1.editingFinished.connect(self.update_th_m_1)
        self.ui.text_th_m_2.editingFinished.connect(self.update_th_m_2)
        self.ui.text_th_m_3.editingFinished.connect(self.update_th_m_3)
        self.ui.text_th_m_4.editingFinished.connect(self.update_th_m_4)
        self.ui.text_th_m_5.editingFinished.connect(self.update_th_m_5)
        self.ui.text_th_m_6.editingFinished.connect(self.update_th_m_6)
        self.ui.text_th_m_7.editingFinished.connect(self.update_th_m_7)
        self.ui.text_nsamp_m.editingFinished.connect(self.update_nsamp_m)

        self.ui.text_th_l_0.editingFinished.connect(self.update_th_l_0)
        self.ui.text_th_l_1.editingFinished.connect(self.update_th_l_1)
        self.ui.text_th_l_2.editingFinished.connect(self.update_th_l_2)
        self.ui.text_th_l_3.editingFinished.connect(self.update_th_l_3)
        self.ui.text_th_l_4.editingFinished.connect(self.update_th_l_4)
        self.ui.text_th_l_5.editingFinished.connect(self.update_th_l_5)
        self.ui.text_th_l_6.editingFinished.connect(self.update_th_l_6)
        self.ui.text_th_l_7.editingFinished.connect(self.update_th_l_7)
        self.ui.text_nsamp_l.editingFinished.connect(self.update_nsamp_l)


        self.th_h_0 = 100e-6
        self.th_h_1 = 100e-6
        self.th_h_2 = 100e-6
        self.th_h_3 = 100e-6
        self.th_h_4 = 100e-6
        self.th_h_5 = 100e-6
        self.th_h_6 = 100e-6
        self.th_h_7 = 100e-6
        self.nsamp_h = int(10)

        self.th_m_0 = 10e-6
        self.th_m_1 = 10e-6
        self.th_m_2 = 10e-6
        self.th_m_3 = 10e-6
        self.th_m_4 = 10e-6
        self.th_m_5 = 10e-6
        self.th_m_6 = 10e-6
        self.th_m_7 = 10e-6
        self.nsamp_m = int(100)

        self.th_l_0 = 1e-6
        self.th_l_1 = 1e-6
        self.th_l_2 = 1e-6
        self.th_l_3 = 1e-6
        self.th_l_4 = 1e-6
        self.th_l_5 = 1e-6
        self.th_l_6 = 1e-6
        self.th_l_7 = 1e-6
        self.nsamp_l = int(100)

           
    def update_th_h_0(self):
        self.th_h_0 = float(self.ui.text_th_h_0.text())  
    def update_th_h_1(self):
        self.th_h_1 = float(self.ui.text_th_h_1.text())
    def update_th_h_2(self):
        self.th_h_2 = float(self.ui.text_th_h_2.text())
    def update_th_h_3(self):
        self.th_h_3 = float(self.ui.text_th_h_3.text())
    def update_th_h_4(self):
        self.th_h_4 = float(self.ui.text_th_h_4.text())
    def update_th_h_5(self):
        self.th_h_5 = float(self.ui.text_th_h_5.text())
    def update_th_h_6(self):
        self.th_h_6 = float(self.ui.text_th_h_6.text())
    def update_th_h_7(self):
        self.th_h_7 = float(self.ui.text_th_h_7.text())
    def update_nsamp_h(self):
        self.nsamp_h = int(float(self.ui.text_nsamp_h.text()))

    def update_th_m_0(self):
        self.th_m_0 = float(self.ui.text_th_m_0.text())  
    def update_th_m_1(self):
        self.th_m_1 = float(self.ui.text_th_m_1.text())
    def update_th_m_2(self):
        self.th_m_2 = float(self.ui.text_th_m_2.text())
    def update_th_m_3(self):
        self.th_m_3 = float(self.ui.text_th_m_3.text())
    def update_th_m_4(self):
        self.th_m_4 = float(self.ui.text_th_m_4.text())
    def update_th_m_5(self):
        self.th_m_5 = float(self.ui.text_th_m_5.text())
    def update_th_m_6(self):
        self.th_m_6 = float(self.ui.text_th_m_6.text())
    def update_th_m_7(self):
        self.th_m_7 = float(self.ui.text_th_m_7.text())
    def update_nsamp_m(self):
        self.nsamp_m = int(float(self.ui.text_nsamp_m.text()))

    def update_th_l_0(self):
        self.th_l_0 = float(self.ui.text_th_l_0.text())  
    def update_th_l_1(self):
        self.th_l_1 = float(self.ui.text_th_l_1.text())
    def update_th_l_2(self):
        self.th_l_2 = float(self.ui.text_th_l_2.text())
    def update_th_l_3(self):
        self.th_l_3 = float(self.ui.text_th_l_3.text())
    def update_th_l_4(self):
        self.th_l_4 = float(self.ui.text_th_l_4.text())
    def update_th_l_5(self):
        self.th_l_5 = float(self.ui.text_th_l_5.text())
    def update_th_l_6(self):
        self.th_l_6 = float(self.ui.text_th_l_6.text())
    def update_th_l_7(self):
        self.th_l_7 = float(self.ui.text_th_l_7.text())
    def update_nsamp_l(self):
        self.nsamp_l = int(float(self.ui.text_nsamp_l.text()))


    def get_configuration(self, config):

        config.th_h_0 = float(self.ui.text_th_h_0.text())
        config.th_h_1 = float(self.ui.text_th_h_1.text())
        config.th_h_2 = float(self.ui.text_th_h_2.text())
        config.th_h_3 = float(self.ui.text_th_h_3.text())
        config.th_h_4 = float(self.ui.text_th_h_4.text())
        config.th_h_5 = float(self.ui.text_th_h_5.text())
        config.th_h_6 = float(self.ui.text_th_h_6.text())
        config.th_h_7 = float(self.ui.text_th_h_7.text())
        config.nsamp_h = int(float(self.ui.text_nsamp_h.text()))

        config.th_m_0 = float(self.ui.text_th_m_0.text())
        config.th_m_1 = float(self.ui.text_th_m_1.text())
        config.th_m_2 = float(self.ui.text_th_m_2.text())
        config.th_m_3 = float(self.ui.text_th_m_3.text())
        config.th_m_4 = float(self.ui.text_th_m_4.text())
        config.th_m_5 = float(self.ui.text_th_m_5.text())
        config.th_m_6 = float(self.ui.text_th_m_6.text())
        config.th_m_7 = float(self.ui.text_th_m_7.text())
        config.nsamp_m = int(float(self.ui.text_nsamp_m.text()))

        config.th_l_0 = float(self.ui.text_th_l_0.text())
        config.th_l_1 = float(self.ui.text_th_l_1.text())
        config.th_l_2 = float(self.ui.text_th_l_2.text())
        config.th_l_3 = float(self.ui.text_th_l_3.text())
        config.th_l_4 = float(self.ui.text_th_l_4.text())
        config.th_l_5 = float(self.ui.text_th_l_5.text())
        config.th_l_6 = float(self.ui.text_th_l_6.text())
        config.th_l_7 = float(self.ui.text_th_l_7.text())
        config.nsamp_l = int(float(self.ui.text_nsamp_l.text()))

        return config